// Generated by CoffeeScript 1.3.3
var channels, connect, create, sessionStore, subscriptions;

connect = require('connect');

channels = require('./channels');

subscriptions = require('../websocket/subscriptions');

sessionStore = new connect.session.MemoryStore;

exports.options = {
  maxAge: null
};

exports.store = {
  use: function(nameOrStore, options) {
    var RedisStore;
    return sessionStore = nameOrStore === 'redis' ? (RedisStore = require('connect-redis')(connect), new RedisStore(options)) : nameOrStore;
  },
  get: function() {
    return sessionStore;
  }
};

exports.create = function() {
  var sessionId;
  sessionId = connect.utils.uid(24);
  create(sessionId);
  return sessionId;
};

exports.find = function(sessionId, socketId, cb) {
  return sessionStore.load(sessionId, function(err, session) {
    if (!session) {
      session = create(sessionId);
    }
    session.channel = channels(session, socketId);
    session.setUserId = function(userId, cb) {
      if (cb == null) {
        cb = function() {};
      }
      if (userId) {
        this.userId = userId;
        this._bindToSocket();
      } else if (this.userId) {
        subscriptions.user.remove(this.userId, socketId);
        delete this.userId;
      }
      return this.save(cb);
    };
    session._bindToSocket = function() {
      if (session.userId != null) {
        subscriptions.user.add(session.userId, socketId);
      }
      if ((session.channels != null) && session.channels.length > 0) {
        session.channel._bindToSocket();
      }
      return this;
    };
    session.save = function(cb) {
      return sessionStore.set(sessionId, session, cb);
    };
    session._bindToSocket();
    return cb(session);
  });
};

create = function(sessionId) {
  var session;
  session = new connect.session.Session({
    sessionID: sessionId,
    sessionStore: sessionStore
  });
  session.cookie = {
    maxAge: exports.options.maxAge
  };
  session.save();
  return session;
};
